package com.easou.users.analysis;

import java.io.File;
import java.lang.ref.WeakReference;
import java.text.ParseException;
import java.util.List;
import java.util.Map;
import java.util.concurrent.Executor;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.AlertDialog.Builder;
import android.content.Context;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.os.Process;
import android.text.TextUtils;
import android.view.Gravity;
import android.view.WindowManager;
import android.widget.Toast;


//import com.baidu.location.LocationClient;
//import com.baidu.location.LocationClientOption;
import com.easou.users.analysis.buildreport.ReportBuilder;
import com.easou.users.analysis.collect.ActivityCollect;
import com.easou.users.analysis.collect.AppListCollect;
import com.easou.users.analysis.collect.BehaviorCollect;
import com.easou.users.analysis.collect.CustomCollect;
import com.easou.users.analysis.collect.DatabaseAdapater;
import com.easou.users.analysis.collect.EnventCollect;
import com.easou.users.analysis.collect.ExceptionCollect;
import com.easou.users.analysis.common.CommonConfig;
import com.easou.users.analysis.common.CommonUtil;
import com.easou.users.analysis.common.ConfigLoader;
import com.easou.users.analysis.common.Excutor;
import com.easou.users.analysis.common.GZip;
import com.easou.users.analysis.common.LogUtils;
import com.easou.users.analysis.common.OpenUDID;
import com.easou.users.analysis.common.Scaner;
import com.easou.users.analysis.common.Send;
import com.easou.users.analysis.common.TrafficMonitoring;
import com.easou.users.analysis.entity.ActivityEntity;
import com.easou.users.analysis.entity.AppListEntity;
import com.easou.users.analysis.entity.BehaviorEntitiy;
import com.easou.users.analysis.entity.CustomEntitiy;
import com.easou.users.analysis.entity.EventEntitiy;
import com.easou.users.analysis.exception.GlobalHandler;
//import com.easou.users.analysis.listener.MyLocationListenner;
import com.easou.users.analysis.listener.OnLocationReceivedListener;
import com.easou.users.analysis.mobilephoneInfo.MobilePhoneInfo;

/**
 * 
 * @desc 日志收集和上传。
 */
public class DataCollect {
	private final static String LOG_TAG = DataCollect.class.getName();

	private static long beginTime = 0;// activity 开始时间
	private static String start_millis = null; // The start time point
	private static long start = 0;// onResume的时间
	private static String end_millis = null; // The end time point
	private static long end = 0; // onPause的时间
	private static String duration = null; // run time
	private static String session_id = null;
	private static String activities = null; // currnet activity's name
	private static String preActivity = null;

//	private static MyLocationListenner myListener = null;
//	private static LocationClient mLocationClient = null;
	private static OnLocationReceivedListener locationReceivedListener = null;
	private static boolean needSubmitModileInfo = false;

	private static Object lock = new Object();

	private DataCollect() {

	}

	/**
	 * 设置上传mobile、Activity等日志的服务地址<br>
	 * 需要在调用日志收集方法前调用此方法设置自有的接受服务
	 * 
	 * @param uploadUrl
	 */
	public static void setSDKLogHost(final Context context,String uploadUrl) {	
		// CommonConfig.UPLOAD_USERINFO_PATH = uploadUrl;
	}

	/**
	 * 设置自定义日志的上传地址，如不设置，默认使用sdk普通日志的上传地址
	 * 
	 * @param uploadUrl
	 */
	public static void setCustomLogHost(final Context context,String uploadUrl) {
		// CommonConfig.CUSTOM_LOG_HOST = uploadUrl;
	}

	/**
	 * 暂时不用。还未实现。 <br>
	 * 程序启动时可调用此方法。此方法会触发各类日志的上传动作（依网络环境和上传策略而定）。
	 * 
	 * @param context
	 */
	@Deprecated
	public static void onStart(final Context context) {
		// CommonUtil.setChannelId(context, "");
		// if(CommonConfig.policy == ReportPoicy.START){
		// initSendFile(context);
		// DataCollect2.initSendFile(context);
		// } else if(CommonConfig.policy == ReportPoicy.INTERVAL){
		// Excutor.submit((new Runnable() {
		// @Override
		// public void run() {
		// initSendFile(context);
		// DataCollect2.initSendFile(context);
		// reporthandler.postDelayed(this, CommonConfig.REPORTINTERVAL);
		// }
		// });
		// }
	}

	/**
	 * @Title: setDebugMode
	 * @Description: 设置Debug模式
	 * @param isDebug
	 * @author vic
	 * @return void
	 * @throws
	 */
	public static void setDebugMode(boolean isDebug) {
		CommonConfig.DebugMode = isDebug;
	}

	/**
	 * 设置多少条日志记录上传一次（activity、event、exception日志）,非wifi环境下生效，wifi环境下产生日志后即刻上传。
	 * 
	 * @param context
	 * @param num
	 */
	public static void setLogNumToUpload(Context context, int num) {
		CommonUtil.SetCountLimited2Report(context, num);
	}

	/**
	 * 此方法捕获的是UncaughtException。<br>
	 * 当某一线程因未捕获的异常而即将终止时异常信息会被转发到此处。<br>
	 * 一般的异常和错误信息使用
	 * <code>onError(final Context context,final Class<?> currentClass, final Exception e)</code>
	 * 进行捕获。
	 * 
	 * @param context
	 */
	public static void onError(final Context context) {
		final WeakReference<Context> wf = new WeakReference<Context>(context);
		Context wfContext = wf.get();
		if (wfContext != null) {
			GlobalHandler handler = GlobalHandler.getInstance(wfContext);
			Thread.setDefaultUncaughtExceptionHandler(handler);
		}
	}

	/**
	 * 初始化百度地图
	 * @param address
	 */
	public static void setBaiduMapAddress(String address) {
		MobilePhoneInfo.setCity(address); 
	}
	
	/**
	 * 捕获并记录异常信息到日志，根据一定策略上传日志到服务器。
	 * 
	 * @param context
	 * @param currentClass
	 * @param e
	 */
	public static void onError(final Context context,
			final Class<?> currentClass, final Exception e) {
		final WeakReference<Context> wf = new WeakReference<Context>(context);
		Runnable postErrorInfoRunnable = new Runnable() {
			@Override
			public void run() {
				Context wfContext = wf.get();
				if (wfContext != null) {
					new ExceptionCollect(CommonConfig.TYPE_EXCEPTIONINFO)
							.collect(wfContext, LogUtils.getExceptionEntity(e),
									false);
				}
			}
		};
		Excutor.submit(postErrorInfoRunnable);
	}

	public static void onEvent(Activity activity, String event_id, String status) {
		try {
			onEvent(activity, event_id, status, null);
		} catch (Exception e) {
			CommonUtil.printELog(LOG_TAG + "-submitUserBehavior", "", e);
		}
	}

	/**
	 * 测试打点用
	 * 
	 * @param context
	 * @param event_id
	 * @param status
	 * @param event_paralist
	 */
	public static void onEvent(final Activity activity, final String event_id,
			final String status, final Map<String, String> event_paralist) {
		Context context = activity.getApplicationContext();
		//ywf 添加appid start
		event_paralist.put("appid", CommonUtil.getStringFromAppMetaData(context,"EASOU_APPID",""));	
		if (CommonConfig.DebugMode == true) {
			long startTime = System.currentTimeMillis();
			JSONObject json1 = new JSONObject();
			if (event_paralist != null && event_paralist.size() > 0) {
				if (event_id != null && event_id.toLowerCase().startsWith("b_")
						&& !event_id.toLowerCase().startsWith("b_ad_")) {
					json1 = new JSONObject(event_paralist);			
					final String str = json1.toString();
					new AlertDialog.Builder(activity)
							.setMessage(str)
							.setTitle("事件:" + event_id)
							.setNegativeButton("关闭",
									new DialogInterface.OnClickListener() {
										@Override
										public void onClick(
												DialogInterface dialog,
												int which) {
											dialog.dismiss();
										}
									}).create().show();
					;

				}

			}
		}

		final WeakReference<Context> wf = new WeakReference<Context>(context);
		Excutor.submit(new Runnable() {
			@Override
			public void run() {

				synchronized (lock) {
					Context wfContext = wf.get();
					try {
						JSONObject json1 = new JSONObject();
						String str = "";
						if (event_paralist != null && event_paralist.size() > 0) {
							json1 = new JSONObject(event_paralist);
							str = json1.toString();
						}
						EventEntitiy event = new EventEntitiy();
						event.setEvent_id(event_id);
						event.setStatus(status);
						event.setTime(String.valueOf(System.currentTimeMillis()));
						event.setEvent_info(str);
						if (wfContext != null) {
							new EnventCollect(CommonConfig.TYPE_EVENTINFO)
									.collect(wfContext, event, false);
						}

					} catch (Exception e) {
						CommonUtil.printELog(this.getClass().getName(),
								e.getMessage());
					}
				}
			}
		});
	}

	/**
	 * event日志记录
	 * 
	 * @param context
	 * @param event_id
	 * @param status
	 */
	public static void onEvent(Context context, String event_id, String status) {
		try {
			onEvent(context, event_id, status, null);
		} catch (Exception e) {
			CommonUtil.printELog(LOG_TAG + "-submitUserBehavior", "", e);
		}
	}

	/**
	 * event日志-详细
	 * 
	 * @param context
	 * @param event_id
	 * @param status
	 * @param event_paralist
	 */
	public static void onEvent(final Context context, final String event_id,
			final String status, final Map<String, String> event_paralist) {
		//ywf 添加appid start
		event_paralist.put("appid", CommonUtil.getStringFromAppMetaData(context,"EASOU_APPID",""));
		if (CommonConfig.DebugMode == true) {
			long startTime = System.currentTimeMillis();
			JSONObject json1 = new JSONObject();
			if (event_paralist != null && event_paralist.size() > 0) {
				if (event_id != null && event_id.toLowerCase().startsWith("b_")
						&& !event_id.toLowerCase().startsWith("b_ad_")) {
					json1 = new JSONObject(event_paralist);
					final String str = json1.toString();

					Dialog dialog = new AlertDialog.Builder(context)
							.setMessage(str)
							.setTitle("事件:" + event_id)
							.setNegativeButton("关闭",
									new DialogInterface.OnClickListener() {
										@Override
										public void onClick(DialogInterface dialog,int which) {
											dialog.dismiss();
										}
									}).create();
					dialog.getWindow().setType(WindowManager.LayoutParams.TYPE_SYSTEM_ALERT);
					dialog.show();

					// Toast4Test.getIntance().showToast(context, event_id, str,
					// event_paralist.size());
					// Toast toast = Toast.makeText(context, "eventId:" +
					// event_id + ","+str, Toast.LENGTH_LONG);
					// toast.setGravity(Gravity.CENTER, 0, 0);
					// if(event_paralist.size() > 10 ){
					// CommonUtil.showToast(toast, 40);
					// }else{
					// CommonUtil.showToast(toast, 20);
					// }
				}

			}
		}

		final WeakReference<Context> wf = new WeakReference<Context>(context);
		Excutor.submit(new Runnable() {
			@Override
			public void run() {
				synchronized (lock) {
					Context wfContext = wf.get();
					try {
						JSONObject json1 = new JSONObject();
						String str = "";
						if (event_paralist != null && event_paralist.size() > 0) {
							json1 = new JSONObject(event_paralist);
							str = json1.toString();
						}
						EventEntitiy event = new EventEntitiy();
						event.setEvent_id(event_id);
						event.setStatus(status);
						event.setTime(String.valueOf(System.currentTimeMillis()));
						event.setEvent_info(str);
						if (wfContext != null) {
							if (event_id.equalsIgnoreCase("b_visit")
									|| event_id.equalsIgnoreCase("b_pageClick")
									|| event_id.equalsIgnoreCase("b_subs")
									|| event_id.equalsIgnoreCase("b_search_click")
									|| event_id.equalsIgnoreCase("b_buy")
									|| event_id.equalsIgnoreCase("b_incharge")) {
								new EnventCollect(CommonConfig.TYPE_EVENTINFO).collect(wfContext, event, true);
							} else {
								new EnventCollect(CommonConfig.TYPE_EVENTINFO).collect(wfContext, event, false);
							}
						}
					} catch (Exception e) {
						CommonUtil.printELog(this.getClass().getName(),e.getMessage());
					}
				}
			}
		});
	}

	/**
	 * custom日志-详细
	 * 
	 * @param context
	 * @param event_id
	 * @param status
	 * @param event_paralist
	 */
	public static void uploadCustomLog(final Context context,
			final Map<String, Object> custom_paralist) {
		final WeakReference<Context> wf = new WeakReference<Context>(context);
		Excutor.submit(new Runnable() {
			@Override
			public void run() {
				synchronized (lock) {
					try {
						JSONObject json1 = new JSONObject();
						String str = "";
						if (custom_paralist != null && custom_paralist.size() > 0) {
							json1 = new JSONObject(custom_paralist);
							str = json1.toString();
						}
						CustomEntitiy event = new CustomEntitiy();
						event.setCustom_log(str);
						Context mfContext = wf.get();
						if (mfContext != null) {
							new CustomCollect(CommonConfig.TYPE_CUSTOMLOG).collect(mfContext, event, false);
						}
					} catch (Exception e) {
						CommonUtil.printELog(this.getClass().getName(),e.getMessage());
					}
				}
			}
		});

	}

	/**
	 * 调用方式：DataCollect.uploadAppList 实时上传用户APP列表
	 * 
	 * @param appUdid
	 *            小说唯一用户标识
	 * @param isUp
	 *            是否升级用户 >>> 1:是 0:否
	 * @param btim
	 *            开始获取APPLIST时间
	 * @param ctim
	 *            开始调接口时间
	 * @param paras
	 *            APP列表 : 包名1\t应用名1\t版本1[}包名2\t应用名2\t版本2[}.....
	 */
	public static void uploadAppList(final Context context,
			final String appUdid, final String isUp, final Long btim,
			final Long ctim, final String paras) {

		final WeakReference<Context> wf = new WeakReference<Context>(context);
		Excutor.submit(new Runnable() {
			@Override
			public void run() {
				synchronized (lock) {
					Context mfContext = wf.get();
					if (mfContext != null) {
						// ##### APPLIST 不需要写数据库，不通过原来的方式上传。#######
						// new
						// AppListCollect(CommonConfig.TYPE_APPLIST).collect(mfContext,ale,true);		
						JSONObject appListLog = new JSONObject();
						try {
							OpenUDID.syncContext(mfContext);
							appListLog.put("type",CommonConfig.TYPE_APPLIST_INFO);
							appListLog.put("phone_udid",OpenUDID.getCorpUDID("com.easou"));
							appListLog.put("appkey",CommonUtil.getAppKey(mfContext));
							appListLog.put("appUdid", appUdid);
							appListLog.put("isUp", isUp);
							appListLog.put("btim", btim);
							appListLog.put("ctim", ctim);
							//添加appid
							String appId = CommonUtil.getStringFromAppMetaData(context,"EASOU_APPID","");
							appListLog.put("appid", appId);
							appListLog.put("paras", paras);
							String info = appListLog.toString();
							byte[] infoGzip = GZip.compress_(context, info);							
							Send.getSend().sendFile2ServerForAppList(mfContext,CommonUtil.getUpLoadUserInfoPath(context),infoGzip, CommonConfig.TYPE_APPLIST, 30000,30000);
							// ReportBuilder builder = new
							// ReportBuilder(mfContext,CommonConfig.TYPE_APPLIST);
							// if(builder.genRealTimeLogPath(info)){
							// String logPath = builder.getFilePath();
							// Send.getSend().sendFile2Server(mfContext,
							// CommonConfig.UPLOAD_USERINFO_PATH, logPath,
							// CommonConfig.TYPE_APPLIST,30000,30000);
							// }
							CommonUtil.printDLog("easou_sdk", "applist_log = "+ info);
						} catch (JSONException e) {CommonUtil.printELog(LOG_TAG + "-uploadAppList","", e);
						}
					}
				}
			}
		});
	}

	/**
	 * 如果使用自定义上传策略，建议在程序退出时调用此方法确保日志全部上传。此方法为异步方法，建议在启动时调用
	 * 
	 * @param context
	 */
	public static void uploadAllLogsOnStart(final Context context) {
		final WeakReference<Context> wf = new WeakReference<Context>(context);

		Excutor.submit(new Runnable() {
			@Override
			public void run() {
				synchronized (lock) {
					Context wfContext = wf.get();
					if (wfContext != null) {
						new EnventCollect(CommonConfig.TYPE_EVENTINFO).collect(
								wfContext, null, false);
						new ExceptionCollect(CommonConfig.TYPE_EXCEPTIONINFO)
								.collect(wfContext, null, false);
						new ActivityCollect(CommonConfig.TYPE_ACTIVITYINFO)
								.collect(wfContext, null, false);
						new BehaviorCollect(CommonConfig.TYPE_BEHAVIORINFO)
								.collect(wfContext, null, false);
					}
				}
			}
		});
	}

	/**
	 * 如果使用自定义上传策略，建议在程序退出时调用此方法确保日志全部上传。<br>
	 * <b>注意：</b>此方法为同步方法，可以在退出应用时调用（如果网络有问题可能导致应用停顿），或者在后台service调用。
	 * 
	 * @param context
	 */
	public static void uploadAllLogsOnQuit(final Context context) {
		final WeakReference<Context> wf = new WeakReference<Context>(context);
		Context wfContext = wf.get();
		if (wfContext != null) {
			new EnventCollect(CommonConfig.TYPE_EVENTINFO).collectSyn(
					wfContext, null);
			new ExceptionCollect(CommonConfig.TYPE_EXCEPTIONINFO).collectSyn(
					wfContext, null);
			new ActivityCollect(CommonConfig.TYPE_ACTIVITYINFO).collectSyn(
					wfContext, null);
			new BehaviorCollect(CommonConfig.TYPE_BEHAVIORINFO).collectSyn(
					wfContext, null);
		}
	}
	/**
	 * 上传用户设备信息
	 * 
	 * @param context
	 */
	private static void submitMobileInfo(final Context context) {
		Runnable runnable = new Runnable() {
			@Override
			public void run() {
				synchronized (lock) {
					try {
						String rt_cpid = CommonUtil.getChannelIdRealTime(context);  //渠道 cpid
						boolean cpid_changed = !CommonUtil.getPreChannelId(context).equals(rt_cpid); //渠道是否更新
						boolean version_changed = !CommonUtil.getPreVersion(context).equals(CommonUtil.getVersion(context)); //版本是否更新
						if (CommonUtil.getMInfoFlag(context) == false || cpid_changed || version_changed) {
							CommonUtil.printDLog("easou_sdk", "重新上传MobileInfo");
							OpenUDID.syncContext(context.getApplicationContext());
							if (cpid_changed) {
								CommonUtil.printDLog("easou_sdk", "渠道id发生改变：");
								CommonUtil.setLastChannelId(context,CommonUtil.getPreChannelId(context));
								CommonUtil.setPreChannelId(context, rt_cpid);
								CommonUtil.setChannelId(context, rt_cpid);
							}
							if (version_changed) {
								CommonUtil.printDLog("easou_sdk", "版本发生改变：");
								CommonUtil.savePreVersion(context,CommonUtil.getVersion(context)); //设置当前版本名称
								//没有设置版本名称
							}
							JSONObject mobileInfo = new MobilePhoneInfo(context).encapsulationInfo();
							ReportBuilder reportBuilder = new ReportBuilder(context, CommonConfig.TYPE_MOBILEINFO);
							String info = mobileInfo.toString();
							CommonUtil.printDLog("easou_sdk","提交mobileInfo ---> " + info);
							if (reportBuilder.buildReport(GZip.compress_(context, info),CommonConfig.TYPE_MOBILEINFO)) {
								// 标记已经上传过 ---####在 SDK 3.0.6 version
								// 337行代码与338行代码挑换顺序####
								CommonUtil.setMInfoFlag(context, true);
								Send.getSend().sendReport(context,CommonConfig.TYPE_MOBILEINFO);
							}
						}
					} catch (Exception e) {
						CommonUtil.printELog(LOG_TAG + "-submitMobileInfo", "",e);
					}
				}
			}
		};
		Excutor.submit(runnable);
	}

	/**
	 * 是否第一次运行
	 * 
	 * @param context
	 * @return
	 */
	public static boolean isFirstRun(Context context) {
		if (MobilePhoneInfo.getFirst(context) == 1)
			return true;
		return false;
	}

	/**
	 * 提交用户行为
	 * 
	 * @param context
	 * @param operation
	 * @param info
	 */
	public static void submitUserBehavior(Context context, String operation,
			String info) {
		try {
			final WeakReference<Context> wf = new WeakReference<Context>(
					context);
			Context wfContext = wf.get();
			if (wfContext != null) {
				new BehaviorCollect(CommonConfig.TYPE_BEHAVIORINFO).collect(
						wfContext,
						new BehaviorEntitiy(operation, String.valueOf(System
								.currentTimeMillis()), info).setFirsRun(false),
						false);
			}
		} catch (Exception e) {
			CommonUtil.printELog(LOG_TAG, e.getMessage());
		}
	}

	/**
	 * 提交用户行为
	 * 
	 * @param context
	 * @param operation
	 * @param map
	 */
	public static void submitUserBehaviors(Context context, String operation,
			Map<String, String> map) {
		final WeakReference<Context> wf = new WeakReference<Context>(context);
		Context wfContext = wf.get();
		try {
			JSONObject json = new JSONObject();
			json.put("data", 1);
			json.put("values", new JSONObject(map));
			if (wfContext != null) {
				new BehaviorCollect(CommonConfig.TYPE_BEHAVIORINFO).collect(
						wfContext,
						new BehaviorEntitiy(operation, String.valueOf(System
								.currentTimeMillis()), json.toString())
								.setFirsRun(false), false);
			}
		} catch (JSONException e) {
			CommonUtil.printELog(LOG_TAG + "-submitUserBehaviorStart", "", e);
		}
	}

	/**
	 * get sessionId
	 * 
	 * @param context
	 * @return
	 * 
	 *         private static String getSessionId(Context context) { if
	 *         (session_id == null) { try { session_id =
	 *         generateSeesion(context); } catch (Exception e) {
	 *         CommonUtil.printELog(LOG_TAG + "-getSessionId", "", e); } }
	 *         return session_id; }
	 */

	/**
	 * @Title: setSessionContinueMillis
	 * @Description: 设置session超时时间(单位毫秒)
	 * @param paramLong
	 * @author vic
	 * @return void
	 * @throws
	 */
	public static void setSessionContinueMillis(long millis) {
		CommonConfig.SESSION_CONTINUE_MILLIS = millis;
	}

	/**
	 * 提交设备信息(如果城市信息为空则暂不提交),在程序启动时调用，调用次序在百度定位初始化之后。
	 * 
	 * @param context
	 */
	public static void trySubmitMobileInfo(Context context) {
		String city = CommonUtil.getCityInfo(context);
		if (!TextUtils.isEmpty(city)) {
			CommonUtil.printDLog("easou_sdk", "  --> submit city #" + city);
			submitMobileInfo(context);
			needSubmitModileInfo = false;
		} else {
			CommonUtil.printDLog("easou_sdk", "  --> setCity");
			needSubmitModileInfo = true;
		}

	}

	/**
	 * 不论城市信息能否取到都要上传手机信息,在程序启动时调用，调用次序在百度定位初始化之后。
	 * 
	 * @param context
	 */
	public static void trySubmitMobileInfoForce(Context context) {
		submitMobileInfo(context);
	}

	/**
	 * activity进入onPause时记录相应信息
	 * 
	 * @param context
	 */
	public static void onPause(final Context context) {
		final long sesionTime = System.currentTimeMillis() - beginTime;
		CommonUtil.printDLog("easou_sdk_sesionTime", "" + sesionTime);
		final WeakReference<Context> wf = new WeakReference<Context>(context);
		Runnable postOnPauseinfoRunnable = new Runnable() {
			@Override
			public void run() {
				synchronized (lock) {
					Context wfContext = wf.get();
					if (wfContext != null) {
						updateActivityLogInfOnPause(context, sesionTime);
						saveOnPauseInfoToPreferences(context);
					}

				}
			}
		};
		Excutor.submit(postOnPauseinfoRunnable);
	}

	/**
	 * 更新最近一条activity日志信息（使用时间、上下行流量等）
	 * 
	 * @param context
	 * @param sesionTime
	 */
	private static void updateActivityLogInfOnPause(Context context,
			long sesionTime) {
		if (sesionTime <= 0)
			return;
		List<ActivityEntity> alist = DatabaseAdapater.getDatabaseAdapater(
				context).getActivities();
		if (alist != null && alist.size() > 0) {
			ActivityEntity a = alist.get(alist.size() - 1);
			// 累计使用时间
			long _ut = 0;
			String ut = a.getUse_time();
			if (null != ut && !"".equals(ut)) {
				_ut = Long.parseLong(ut);
			}
			_ut += sesionTime;
			a.setUse_time(String.valueOf(_ut));
			a.upTraffic = TrafficMonitoring
					.monitoringEachApplicationSend(Process.myUid())
					- a.upTraffic;
			a.downTraffic = TrafficMonitoring
					.monitoringEachApplicationReceive(Process.myUid())
					- a.downTraffic;
			DatabaseAdapater.getDatabaseAdapater(context).updateActivity(a);
			ActivityCollect ac = new ActivityCollect(
					CommonConfig.TYPE_ACTIVITYINFO);
			ac.collect(context, false);
		}

	}

	/**
	 * 将activity名称、包名称、使用时长等保存到SharedPreferences (common_prefs)
	 * 
	 * @param context
	 */
	private static void saveOnPauseInfoToPreferences(Context context) {
		preActivity = CommonUtil.getActivityName(context);
		end_millis = CommonUtil.getTime();
		end = Long.valueOf(System.currentTimeMillis());
		duration = end - start + "";
		JSONObject info = getJSONObject(context);
		CommonUtil.printDLog(LOG_TAG + "-saveOnPauseInfoToPreferences", info
				+ "");
		SharedPreferences localSharedPreferences = context
				.getSharedPreferences(CommonConfig.COMMON_PREFS,
						Context.MODE_PRIVATE);
		synchronized (SdkLock.localSharedPreferencesLock) {
			localSharedPreferences.edit()
					.putString("easou_agent_activity", info.toString())
					.commit();
		}
	}

	/**
	 * activity进入onResume时记录相应信息
	 * 
	 * @param context
	 */
	public static void onResume(final Context context) {
		// 记录下activiity开始时间 add by andrew
		beginTime = System.currentTimeMillis();
		final WeakReference<Context> wf = new WeakReference<Context>(context);
		Runnable postOnResumeinfoRunnable = new Runnable() {
			@Override
			public void run() {
				synchronized (lock) {
					Context wfContext = wf.get();
					if (wfContext != null) {
						saveActivityLogInfOnResume(context);
						Scaner.scan(context);
					}
				}
			}
		};
		Excutor.submit(postOnResumeinfoRunnable);
	}

	/**
	 * 保存activity相关信息---------------------------------------------------
	 * 
	 * @param context
	 */
	private static void saveActivityLogInfOnResume(Context context) {
		activities = CommonUtil.getActivityName(context);
		CommonUtil.printDLog(LOG_TAG + "-saveActivityLogInfOnResume",
				preActivity + ":" + activities);
		ActivityEntity a = new ActivityEntity();
		a.setTime(String.valueOf(System.currentTimeMillis()));
		CommonUtil.printDLog(LOG_TAG + "-saveActivityLogInfOnResume",
				preActivity + ":" + activities);
		a.setRefer_activity(null == preActivity ? "" : preActivity);
		a.setCurrent_activity(null == activities ? "" : activities);
		CommonUtil.printDLog("easou_sdk",
				a.getRefer_activity() + " ---> " + a.getCurrent_activity());
		a.upTraffic = TrafficMonitoring.monitoringEachApplicationSend(Process
				.myUid());
		a.downTraffic = TrafficMonitoring
				.monitoringEachApplicationReceive(Process.myUid());
		boolean timeout = false;
		if (session_id == null || isSessionTimeout(context, activities)) {
			timeout = true;
			try {
				session_id = generateSeesion(context);
			} catch (ParseException e) {
				CommonUtil.printELog(LOG_TAG, e.getMessage());
			}
		}
		final boolean force = timeout;

		final WeakReference<Context> wf = new WeakReference<Context>(context);
		Context wfContext = wf.get();
		if (wfContext != null) {
			ActivityCollect ac = new ActivityCollect(
					CommonConfig.TYPE_ACTIVITYINFO);
			if (force) {
				ac.collect(wfContext, force);
			}
			ac.saveLogDataToDb(wfContext, a);
		}

		if (null != preActivity && !preActivity.contains("easou")) {// 跟第一次一样
			preActivity = activities;
		}

		start_millis = CommonUtil.getTime();
		start = Long.valueOf(System.currentTimeMillis());
	}

	/**
	 * 检测session是否超时。(onPause到onResume的时间是否超过指定时长)
	 * 
	 * @param context
	 * @param activityName
	 * @return
	 */
	public static boolean isSessionTimeout(Context context, String activityName) {
		boolean isSessionTimeout = Boolean.FALSE;
		SharedPreferences localSharedPreferences = context
				.getSharedPreferences(CommonConfig.COMMON_PREFS,
						Context.MODE_PRIVATE);
		String json = localSharedPreferences.getString("easou_agent_activity",
				"");
		if (!"".equals(json)) {
			try {
				JSONObject j = new JSONObject(json);

				if (null != activityName
						&& activityName.equals(j.optString("activities"))) {
					long start = Long.valueOf(System.currentTimeMillis());
					long end = j.optLong("end");
					if (start - end > CommonConfig.SESSION_CONTINUE_MILLIS) {
						isSessionTimeout = Boolean.TRUE;
					}
				}
			} catch (JSONException e) {
				CommonUtil.printELog(LOG_TAG + "-isSessionTimeout", "", e);
			}
		}
		return isSessionTimeout;
	}

	/**
	 * create sessionID
	 * 
	 * @param context
	 * @return sessionId
	 * @throws ParseException
	 */
	private static String generateSeesion(Context context)
			throws ParseException {
		String sessionId = "";
		OpenUDID.syncContext(context.getApplicationContext());
		String uuid = OpenUDID.getCorpUDID("com.easou");
		sessionId = uuid + System.currentTimeMillis();
		return sessionId;
	}

	private static JSONObject getJSONObject(Context context) {
		JSONObject info = new JSONObject();
		try {
			info.put("session_id", session_id);
			info.put("start_millis", start_millis);
			info.put("end_millis", end_millis);
			info.put("duration", duration);
			info.put("end", end);
			info.put("activities", activities);
		} catch (JSONException e) {
			CommonUtil.printELog(LOG_TAG + "-getJSONObject", "", e);
		}
		return info;
	}

	/**
	 * 调用百度定位，地址和坐标信息记录到SharedPreferences中。使用saveLocation方法代替
	 * 
	 * @param context
	 */
//	@Deprecated
//	public static void initBaiduMap(final Context context) {
//		final WeakReference<Context> wf = new WeakReference<Context>(context);
//		Context wfContext = wf.get();
//		if (wfContext != null) {
//			CommonUtil.printDLog("easou_sdk", " --> initBaiduMap");
//			myListener = new MyLocationListenner(wfContext,
//					locationReceivedListener);
//			mLocationClient = new LocationClient(wfContext);
//			mLocationClient.registerLocationListener(myListener);
//			setLocationOption();
//			mLocationClient.requestLocation();
//		}
//
//	}

	/**
	 * 获取位置并保存，使用此方法代替initBaiduMap()方法。<br>
	 * 在有网络时有效。
	 */
//	public static void saveLocation(final Context context) {
//		if (CommonUtil.isNetworkAvailable(context))
//			try {
//				LocationClient locationClient = new LocationClient(context);
//				locationClient
//						.registerLocationListener(new MyLocationListenner(
//								context, null));
//				locationClient.setLocOption(getLocationOptions());
//				locationClient.start();
//				locationClient.requestLocation();
//				locationClient.stop();
//			} catch (Exception e) {
//				CommonUtil.printELog(LOG_TAG, e.getMessage());
//			}
//	}

	/**
	 * 此方法暂时保留，但不推荐使用，请使用<br>
	 * <code>requestBdLocation(Context context,OnLocationReceivedListener listener)</cod>代替
	 */
	@Deprecated
//	public static void requestBdLocation() {
//		if (!mLocationClient.isStarted())
//			mLocationClient.start();
//		mLocationClient.requestLocation();
//		mLocationClient.stop();
//	}

	/**
	 * 请求地理位置(<i>推荐使用此方法代替不带参数的同名方法<i>)，如果listner参数为空则等效与saveLocation()方法。
	 * 在OnLocationReceivedListener中可定制需求。
	 * 
	 * @param context
	 * @param listener
	 */
//	public static void requestBdLocation(Context context,
//			OnLocationReceivedListener listener) {
//		if (CommonUtil.isNetworkAvailable(context)) {
//			try {
//				LocationClient locationClient = new LocationClient(context);
//				locationClient
//						.registerLocationListener(new MyLocationListenner(
//								context, listener));
//				locationClient.setLocOption(getLocationOptions());
//				locationClient.start();
//				locationClient.requestLocation();
//				locationClient.stop();
//			} catch (Exception e) {
//				CommonUtil.printELog(LOG_TAG, e.getMessage());
//			}
//		}
//	}

	/**
	 * 百度定位设置
	 */
//	private static void setLocationOption() {
//		LocationClientOption option = new LocationClientOption();
//		option.setOpenGps(false); // 打开gps
//		option.setCoorType("bd09ll"); // 设置坐标类型
//		option.setAddrType("all"); // 设置地址信息，仅设置为“all”时有地址信息，默认无地址信息
//		// option.setScanSpan(10000); //设置定位模式，小于1秒则一次定位;大于等于1秒则定时定位
//		option.setScanSpan(0); // 设置定位模式，小于1秒则一次定位;大于等于1秒则定时定位
//		// option.setServiceName("com.baidu.location.service_v2.ss");
//		mLocationClient.setLocOption(option);
//	}

	/**
	 * @return LocationClientOption
	 */
//	private static LocationClientOption getLocationOptions() {
//		LocationClientOption option = new LocationClientOption();
//		option.setOpenGps(false); // 打开gps
//		option.setCoorType("bd09ll"); // 设置坐标类型
//		option.setAddrType("all"); // 设置地址信息，仅设置为“all”时有地址信息，默认无地址信息
//		// option.setScanSpan(10000); //设置定位模式，小于1秒则一次定位;大于等于1秒则定时定位
//		option.setScanSpan(0); // 设置定位模式，小于1秒则一次定位;大于等于1秒则定时定位
//		// option.setServiceName("com.baidu.location.service_v2.ss");
//		return option;
//	}

	/**
	 * get sessionId
	 * 
	 * @param context
	 * @return
	 */
	public static String getSessionId(Context context) {
		if (session_id == null) {
			try {
				session_id = generateSeesion(context);
			} catch (Exception e) {
				CommonUtil.printELog(LOG_TAG + "-getSessionId", "", e);
			}
		}
		return session_id;
	}

	/**
	 * 注册自定义监听. <br>
	 * 咱保留此方法。请使用requestBdLocation(Context context,OnLocationReceivedListener
	 * listener)代替。
	 * 
	 * @param context
	 * @param listener
	 */
	@Deprecated
	public static void setOnLocationReceivedListener(final Context context,
			OnLocationReceivedListener listener) {
		locationReceivedListener = listener;
	}

	public static boolean isNeedSubmitModileInfo() {
		return needSubmitModileInfo;
	}

	/**
	 * 退出应用时调用
	 */
	public static void exit(Context context) {
		DatabaseAdapater.getDatabaseAdapater(context).close();
	}
}