package com.easou.users.analysis.common;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

/**
 * 配置文件加载类
 * 
 * @author ywf
 */
public final class ConfigLoader {

	private static Properties props = new Properties();
	static {
		InputStream in = null;
		try {
			in = ConfigLoader.class.getResourceAsStream("config.properties");
		} catch (Exception ex) {
			throw new NullPointerException(
					"Can not found properties configure file: config.properties");
		}
		if (in != null) {
			try {
				props.load(in);
				in.close();
			} catch (IOException ex) {
				throw new NullPointerException(
						"Object propsLoaderClassPathUtil is null");
			}
		}
	}

	/**
	 * 根据Properties中的key和默认的值获取value,如果根据key获取不到值,则返回传入的默认值ֵ
	 * 
	 * @param key
	 * @return
	 */
	public synchronized static String getProperties(String key) {
		return props.getProperty(key, "http://tjlog.easou.com:8900/up");
	}
}
