package com.easou.users.analysis.common;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.UUID;

import android.annotation.SuppressLint;
import android.bluetooth.BluetoothAdapter;
import android.content.Context;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.os.Build;
import android.provider.Settings.Secure;
import android.telephony.TelephonyManager;

@SuppressLint("DefaultLocale")
public class OpenUDID {
	private final static String LOG_TAG = OpenUDID.class.getName();

	private static String _openUdid;
	private static String _openUdid2;
	// #############_openUdid1保留了原来的_openUdid生成规则，目前提供给无敌锁频用。########//
	private static String _openUdid1;
	private static String _srcCode;
	private static long _time;
	private final static boolean _UseImeiFailback = true; // false if you don't
															// wanna include
															// READ_PHONE_STATE
															// permission

	// we recommend adding BT permission over READ_PHONE_STATE permission as the
	// will be less privacy concerns
	private final static boolean _UseBlueToothFailback = true; // false if you
																// don't wanna
																// include BT
																// permission or
																// android 1.6

	public static void syncContext(Context mContext) {
		if (_openUdid == null) {
			try {
				SharedPreferences mPreferences = mContext.getSharedPreferences(
						CommonConfig.COMMON_PREFS, Context.MODE_PRIVATE);
				String _keyInPref = mPreferences.getString(
						CommonConfig.PREF_KEY, null);
				long _keyTime = mPreferences.getLong(CommonConfig.TIME, 0);
				if (null == _keyInPref || _keyTime == 0
						|| "null".equals(_keyInPref)) {
					generateOpenUDIDInContext(mContext);
					Editor e = mPreferences.edit();
					e.putString(CommonConfig.PREF_KEY, _openUdid);
					e.putLong(CommonConfig.TIME, _time);
					e.putString(CommonConfig.SRC_CODE, _srcCode);
					e.commit();
				} else if (_keyInPref
						.equalsIgnoreCase("WIFIMAC:02:00:00:00:00:00")) {
					generateOpenUDIDInContext(mContext);
					Editor e = mPreferences.edit();
					e.putString(CommonConfig.PREF_KEY, _openUdid);
					e.putLong(CommonConfig.TIME, _keyTime);
					e.putString(CommonConfig.SRC_CODE, _srcCode);
					e.commit();
				} else {
					_openUdid = _keyInPref;
					_time = _keyTime;
				}
			} catch (Exception e) {
				CommonUtil.printDLog(
						LOG_TAG,
						e.getMessage() == null ? "syncContext error" : e
								.getMessage());
			}
		}

		if (_openUdid2 == null) {
			try {
				SharedPreferences mPreferences = mContext.getSharedPreferences(
						CommonConfig.COMMON_PREFS, Context.MODE_PRIVATE);
				String _keyInPref2 = mPreferences.getString(
						CommonConfig.PREF_KEY2, null);
				if (null == _keyInPref2) {
					generateOpenUDID2InContext(mContext);
					Editor e = mPreferences.edit();
					e.putString(CommonConfig.PREF_KEY2, _openUdid2);
					e.commit();
				} else {
					_openUdid2 = _keyInPref2;
				}
			} catch (Exception e) {
				CommonUtil.printDLog(
						LOG_TAG,
						e.getMessage() == null ? "syncContext error" : e
								.getMessage());
			}
		}

		if (_openUdid1 == null) {
			try {
				SharedPreferences mPreferences = mContext.getSharedPreferences(
						CommonConfig.COMMON_PREFS, Context.MODE_PRIVATE);
				String _keyInPref = mPreferences.getString(
						CommonConfig.OLD_PREF_KEY, null);
				if (_keyInPref == null) {
					String _keyInPref1 = mPreferences.getString(
							CommonConfig.PREF_KEY1, null);
					if (null == _keyInPref1) {
						generateOpenUDID1InContext(mContext);
						Editor e = mPreferences.edit();
						e.putString(CommonConfig.PREF_KEY1, _openUdid1);
						e.commit();
					} else {
						_openUdid1 = _keyInPref1;
					}
				} else {
					_openUdid1 = _keyInPref;
				}

			} catch (Exception e) {
				CommonUtil.printDLog(
						LOG_TAG,
						e.getMessage() == null ? "syncContext error" : e
								.getMessage());
			}
		}
	}

	public static String getOpenUDID(Context mContext) {
		if (_openUdid == null) {
			try {
				SharedPreferences mPreferences = mContext.getSharedPreferences(
						CommonConfig.COMMON_PREFS, Context.MODE_PRIVATE);
				String _keyInPref = mPreferences.getString(
						CommonConfig.PREF_KEY, null);
				long _keyTime = mPreferences.getLong(CommonConfig.TIME, 0);
				if (null == _keyInPref || _keyTime == 0) {
					generateOpenUDIDInContext(mContext);
					Editor e = mPreferences.edit();
					e.putString(CommonConfig.PREF_KEY, _openUdid);
					e.putLong(CommonConfig.TIME, _time);
					e.commit();
				} else {
					_openUdid = _keyInPref;
					_time = _keyTime;
				}
			} catch (Exception e) {
				CommonUtil.printDLog(
						LOG_TAG,
						e.getMessage() == null ? "syncContext error" : e
								.getMessage());
			}
		}
		return getCorpUDID("com.easou") == null ? "" : getCorpUDID("com.easou");
	}

	public static String getOpenUDID2(Context mContext) {
		if (_openUdid2 == null) {
			try {
				SharedPreferences mPreferences = mContext.getSharedPreferences(
						CommonConfig.COMMON_PREFS, Context.MODE_PRIVATE);
				String _keyInPref = mPreferences.getString(
						CommonConfig.PREF_KEY, null);
				if (null == _keyInPref) {
					generateOpenUDID2InContext(mContext);
					Editor e = mPreferences.edit();
					e.putString(CommonConfig.PREF_KEY, _openUdid2);
					e.putLong(CommonConfig.TIME, _time);
					e.commit();
				} else {
					_openUdid2 = _keyInPref;
				}
			} catch (Exception e) {
				CommonUtil.printDLog(
						LOG_TAG,
						e.getMessage() == null ? "syncContext error" : e
								.getMessage());
			}
		}
		return getCorpUDID2("com.easou") == null ? ""
				: getCorpUDID2("com.easou");
	}

	public static String getOpenUDIDInContext() {
		return _openUdid;
	}

	public static String getOpenUDID2InContext() {
		return _openUdid2;
	}

	public static String getCorpUDID1(String corpIdentifier) {
		return Md5(String.format("%s.%s", corpIdentifier, _openUdid1));
	}

	public static String getCorpUDID(String corpIdentifier) {
		return Md5(String.format("%s.%s", corpIdentifier,
				getOpenUDIDInContext()));
	}

	public static String getCorpUDID2(String corpIdentifier) {
		return Md5(String.format("%s.%s", corpIdentifier,
				getOpenUDID2InContext()));
	}

	public static long getTime() {
		return _time;
	}

	private static void generateOpenUDID1InContext(Context mContext) {
		// Try to get WIFI MAC
		generateWifiId1(mContext);
		if (null != _openUdid1 && !"".equals(_openUdid1.trim())) {
			return;
		}

		// Try to get the ANDROID_ID
		String _androidId = Secure.getString(mContext.getContentResolver(),
				Secure.ANDROID_ID);
		if (null != _androidId && _androidId.length() > 14
				&& !_androidId.equals("9774d56d682e549c")/* android 2.2 */) {
			_openUdid1 = "ANDROID:" + _androidId;
			return;
		}

		if (_UseImeiFailback) {
			_openUdid1 = null;
			generateImeiId1(mContext);

			if (_openUdid1 != null && !"".equals(_openUdid1.trim())) {
				return;
			}
		}

		if (_UseBlueToothFailback) {
			_openUdid1 = null;
			generateBlueToothId1();
			if (_openUdid1 == null) {
				generateRandomNumber1();
			}
		} else {
			generateRandomNumber1();
		}
	}

	/*
	 * Generate a new OpenUDID
	 */
	private static void generateOpenUDIDInContext(Context mContext) {
		CommonUtil.printDLog(LOG_TAG + "-generateOpenUDIDInContext",
				"Generating openUDID");
		//
		generateIMSI(mContext);
		if (null != _openUdid && !"".equals(_openUdid.trim())) {
			return;
		}

		// Try to get WIFI MAC
		generateWifiId(mContext);
		if (null != _openUdid && !"".equals(_openUdid.trim())) {
			return;
		}

		// try to get UDID from common_prefs.xml key=openudid
		generateOldOpendUdid(mContext);
		if (null != _openUdid && !"".equals(_openUdid.trim())) {
			return;
		}

		generateRandomNumber();

		// Try to get the ANDROID_ID
		// String _androidId = Secure.getString(mContext.getContentResolver(),
		// Secure.ANDROID_ID);
		// if (null != _androidId && _androidId.length() > 14 &&
		// !_androidId.equals("9774d56d682e549c")/* android 2.2 */) {
		// _openUdid = "ANDROID:" + _androidId;
		// _time = System.currentTimeMillis();
		// return;
		// }
		//
		// if (_UseImeiFailback) {
		// _openUdid = null;
		// generateImeiId(mContext);
		//
		// if (_openUdid != null && !"".equals(_openUdid.trim())) {
		// return;
		// }
		// }
		//
		// if (_UseBlueToothFailback) {
		// _openUdid = null;
		// generateBlueToothId();
		// if (_openUdid == null) {
		// generateRandomNumber();
		// }
		// } else {
		// generateRandomNumber();
		// }
		CommonUtil.printDLog(LOG_TAG + "-generateOpenUDIDInContext",
				"_openUdid");
		CommonUtil.printDLog(LOG_TAG + "-generateOpenUDIDInContext", "done");
	}

	private static void generateOldOpendUdid(Context mContext) {
		try {
			SharedPreferences shareData = mContext.getSharedPreferences(
					CommonConfig.COMMON_PREFS, Context.MODE_PRIVATE);
			String oldOpenudid = shareData.getString(CommonConfig.OLD_PREF_KEY,
					null);
			long oldTime = shareData.getLong(CommonConfig.OLD_TIME, 0);
			if (oldOpenudid != null && !"".equals(oldOpenudid)
					&& !"null".equals(oldOpenudid)) {
				_openUdid = oldOpenudid;
				_srcCode = _openUdid;
				_time = oldTime;
			}
		} catch (Exception e) {
			CommonUtil.printELog(LOG_TAG + "-generateOldOpenUdid", "", e);
		}
	}

	public static String getIMSI(Context context) {
		TelephonyManager telephoneManager = (TelephonyManager) context
				.getSystemService(Context.TELEPHONY_SERVICE);
		SharedPreferences shareData = context.getSharedPreferences(
				CommonConfig.COMMON_PREFS, Context.MODE_PRIVATE);
		String temp_imsi = shareData.getString("imsi", null);
		if (null == temp_imsi) {
			temp_imsi = telephoneManager.getSubscriberId();
			if (temp_imsi != null && !"".equals(temp_imsi.trim())) {
				Editor editor = shareData.edit();
				editor.putString("imsi", temp_imsi);
				editor.commit();
			}
		}
		return temp_imsi;
	}

	public static String getIMEI(Context context) {
		TelephonyManager telephoneManager = (TelephonyManager) context
				.getSystemService(Context.TELEPHONY_SERVICE);
		return telephoneManager.getDeviceId();
	}

	private static void generateOpenUDID2InContext(Context mContext) {
		CommonUtil.printDLog(LOG_TAG + "-generateOpenUDID2InContext",
				"Generating openUDID2");
		_openUdid2 = getIMSI(mContext);
		if (null != _openUdid2 && !"".equals(_openUdid2.trim())) {
			return;
		}
		_openUdid2 = getIMEI(mContext);
		if (null != _openUdid2 && !"".equals(_openUdid2.trim())) {
			return;
		}

		if (_UseBlueToothFailback) {
			_openUdid2 = null;
			generateBlueToothId();
			if (_openUdid2 == null) {
				generateRandomNumber2();
			}
		} else {
			generateRandomNumber2();
		}
		CommonUtil.printDLog(LOG_TAG + "-generateOpenUDID2InContext",
				"_openUdid2");
		CommonUtil.printDLog(LOG_TAG + "-generateOpenUDID2InContext", "done");
	}

	private static void generateImeiId1(Context mContext) {
		try {
			TelephonyManager TelephonyMgr = (TelephonyManager) mContext
					.getSystemService(Context.TELEPHONY_SERVICE);
			String szImei = TelephonyMgr.getDeviceId(); // Requires
														// READ_PHONE_STATE

			if (null != szImei && !"".equals(szImei.trim())
					&& !szImei.substring(0, 3).equals("000")) {
				_openUdid1 = "IMEI:" + szImei;
			}
		} catch (Exception e) {
			CommonUtil.printELog(LOG_TAG + "-generateImeiId", "", e);
		}
	}

	private static void generateBlueToothId1() {
		try {
			BluetoothAdapter m_BluetoothAdapter = null; // Local Bluetooth
														// adapter
			m_BluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
			String m_szBTMAC = m_BluetoothAdapter.getAddress();
			if (null != m_szBTMAC && !"".equals(m_szBTMAC.trim())) {
				_openUdid1 = "BTMAC:" + m_szBTMAC;
			}
		} catch (Exception e) {
			CommonUtil.printELog(LOG_TAG + "-generateBlueToothId", "", e);
		}
	}

	private static void generateBlueToothId() {
		try {
			BluetoothAdapter m_BluetoothAdapter = null; // Local Bluetooth
														// adapter
			m_BluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
			String m_szBTMAC = m_BluetoothAdapter.getAddress();
			if (null != m_szBTMAC && !"".equals(m_szBTMAC.trim())) {
				_openUdid2 = "BTMAC:" + m_szBTMAC;
				// _time = System.currentTimeMillis();
			}
		} catch (Exception e) {
			CommonUtil.printELog(LOG_TAG + "-generateBlueToothId", "", e);
		}
	}

	private static void generateIMSI(Context mContext) {
		try {
			SharedPreferences shareData = mContext.getSharedPreferences(
					CommonConfig.COMMON_PREFS, Context.MODE_PRIVATE);
			String temp_imsi = shareData.getString("imsi", null);
			if (null == temp_imsi || "".equals(temp_imsi.trim())) {
				TelephonyManager telephoneManager = (TelephonyManager) mContext
						.getSystemService(Context.TELEPHONY_SERVICE);
				temp_imsi = telephoneManager.getSubscriberId();
				if (temp_imsi != null && !"".equals(temp_imsi.trim())) {
					if (!"null".equals(temp_imsi.trim())
							&& temp_imsi.trim().length() == 15
							&& !temp_imsi
									.matches("^((.*123456.*){1}|(.*[0]{8}.*)|(.*[1]{8}.*)|(.*[a-zA-Z]+.*))$")) {
						// 获取正确的格式付给openUdid
						_openUdid = temp_imsi;
						_srcCode = temp_imsi;
						_time = System.currentTimeMillis();
					}
				}
				Editor editor = shareData.edit();
				editor.putString("imsi", temp_imsi);
				editor.commit();
			} else {
				if (!"null".equals(temp_imsi.trim())
						&& temp_imsi.trim().length() == 15
						&& !temp_imsi
								.matches("^((.*123456.*){1}|(.*[0]{8}.*)|(.*[a-zA-Z]+.*))$")) {
					_openUdid = temp_imsi;
					_srcCode = temp_imsi;
					_time = System.currentTimeMillis();
				}
			}
		} catch (Exception e) {
			CommonUtil.printELog(LOG_TAG + "-generateIMSIId", "", e);
		}
	}

	private static void generateWifiId1(Context mContext) {
		try {
			SharedPreferences shareData = mContext.getSharedPreferences(
					CommonConfig.COMMON_PREFS, Context.MODE_PRIVATE);
			String macSharePre = shareData.getString("mac_address", null);
			if (macSharePre == null || "".equals(macSharePre.trim())) {
				// -------本地文件获取mac为空，通过android系统获取mac。
				WifiManager wifiMan = (WifiManager) mContext
						.getSystemService(Context.WIFI_SERVICE);
				WifiInfo wifiInf = wifiMan.getConnectionInfo();
				CommonUtil.printDLog(LOG_TAG + "-generateWifiId",
						String.format("%s", wifiInf.getMacAddress()));
				String macAddr = wifiInf.getMacAddress();
				if (macAddr != null && !"".equals(macAddr.trim())) {
					// 获得mac 不为空
					if (macAddr.trim().length() == 17) {
						// 获得的mac 长度等于17
						// #####--安装APP时，用户没有同意获取MAC权限，将获取
						// 00:00:00:00:00:00--#####
						if (!macAddr.equals("02:00:00:00:00:00")
								&& !macAddr.equals("00:00:00:00:00:00")
								&& !macAddr.equals("ff:ff:ff:ff:ff:ff")
								&& macAddr
										.matches("^([0-9a-fA-F]{2}(\\:[0-9a-fA-F]{2}){5})$")) {
							// 符合规则
							_openUdid1 = "WIFIMAC:" + macAddr;
						}
					} else {
						// 长度不等于17,但是前17位符合mac规则 例如：00:08:22:be:8d:d0adff
						if (macAddr.trim().length() > 17) {
							String tempMacAddr = macAddr.substring(0, 17);
							if (tempMacAddr
									.matches("^([0-9a-fA-F]{2}(\\:[0-9a-fA-F]{2}){5})$")) {
								_openUdid1 = "WIFIMAC:" + tempMacAddr;
							}
						}
					}
				}
				Editor editor = shareData.edit();
				editor.putString("mac_address", macAddr);
				editor.commit();
			} else {
				// 本地不为空
				if (macSharePre.trim().length() == 17) {
					// 符合规则
					if (!macSharePre.equals("02:00:00:00:00:00")
							&& !macSharePre.equals("00:00:00:00:00:00")
							&& !macSharePre.equals("ff:ff:ff:ff:ff:ff")
							&& macSharePre
									.matches("^([0-9a-fA-F]{2}(\\:[0-9a-fA-F]{2}){5})$")) {
						_openUdid1 = "WIFIMAC:" + macSharePre;
					}
				} else {
					if (macSharePre.trim().length() > 17) {
						macSharePre = macSharePre.substring(0, 17);
						if (macSharePre
								.matches("^([0-9a-fA-F]{2}(\\:[0-9a-fA-F]{2}){5})$")) {
							_openUdid1 = "WIFIMAC:" + macSharePre;
						}
					}
				}
			}
		} catch (Exception e) {
			CommonUtil.printELog(LOG_TAG + "-generateWifiId1", "", e);
		}
	}

	private static void generateWifiId(Context mContext) {
		try {
			SharedPreferences shareData = mContext.getSharedPreferences(
					CommonConfig.COMMON_PREFS, Context.MODE_PRIVATE);
			String macSharePre = shareData.getString("mac_address", null);
			if (macSharePre == null || "".equals(macSharePre.trim())) {
				// -------本地文件获取mac为空，通过android系统获取mac。
				WifiManager wifiMan = (WifiManager) mContext
						.getSystemService(Context.WIFI_SERVICE);
				WifiInfo wifiInf = wifiMan.getConnectionInfo();
				CommonUtil.printDLog(LOG_TAG + "-generateWifiId",
						String.format("%s", wifiInf.getMacAddress()));
				String macAddr = wifiInf.getMacAddress();
				if (macAddr != null && !"".equals(macAddr.trim())) {
					// 获得mac 不为空
					if (macAddr.trim().length() == 17) {
						// 获得的mac 长度等于17
						// #####--安装APP时，用户没有同意获取MAC权限，将获取
						// 00:00:00:00:00:00--#####
						if (!macAddr.equals("02:00:00:00:00:00")
								&& !macAddr.equals("00:00:00:00:00:00")
								&& !macAddr.equals("ff:ff:ff:ff:ff:ff")
								&& macAddr
										.matches("^([0-9a-fA-F]{2}(\\:[0-9a-fA-F]{2}){5})$")) {
							// 符合规则
							_openUdid = "WIFIMAC:" + macAddr;
							_srcCode = _openUdid;
							_time = System.currentTimeMillis();
						}
					} else {
						// 长度不等于17,但是前17位符合mac规则 例如：00:08:22:be:8d:d0adff
						if (macAddr.trim().length() > 17) {
							String tempMacAddr = macAddr.substring(0, 17);
							if (tempMacAddr
									.matches("^([0-9a-fA-F]{2}(\\:[0-9a-fA-F]{2}){5})$")) {
								_openUdid = "WIFIMAC:" + tempMacAddr;
								_srcCode = _openUdid;
								_time = System.currentTimeMillis();
							}
						}
					}
				}
				Editor editor = shareData.edit();
				editor.putString("mac_address", macAddr);
				editor.commit();
			} else {
				// 本地不为空
				if (macSharePre.trim().length() == 17) {
					// 符合规则
					if (!macSharePre.equals("02:00:00:00:00:00")
							&& !macSharePre.equals("00:00:00:00:00:00")
							&& !macSharePre.equals("ff:ff:ff:ff:ff:ff")
							&& macSharePre
									.matches("^([0-9a-fA-F]{2}(\\:[0-9a-fA-F]{2}){5})$")) {
						_openUdid = "WIFIMAC:" + macSharePre;
						_srcCode = _openUdid;
						_time = System.currentTimeMillis();
					}
				} else {
					if (macSharePre.trim().length() > 17) {
						macSharePre = macSharePre.substring(0, 17);
						if (macSharePre
								.matches("^([0-9a-fA-F]{2}(\\:[0-9a-fA-F]{2}){5})$")) {
							_openUdid = "WIFIMAC:" + macSharePre;
							_srcCode = _openUdid;
							_time = System.currentTimeMillis();
						}
					}
				}
			}
		} catch (Exception e) {
			CommonUtil.printELog(LOG_TAG + "-generateWifiId", "", e);
		}
	}

	public static String Md5(String input) {
		MessageDigest m = null;
		try {
			m = MessageDigest.getInstance("MD5");
		} catch (NoSuchAlgorithmException e) {
			CommonUtil.printELog(LOG_TAG + "-Md5", "", e);
		}
		m.update(input.getBytes(), 0, input.length());
		byte p_md5Data[] = m.digest();

		String mOutput = new String();
		for (int i = 0; i < p_md5Data.length; i++) {
			int b = (0xFF & p_md5Data[i]);
			// if it is a single digit, make sure it have 0 in front (proper
			// padding)
			if (b <= 0xF)
				mOutput += "0";
			// add number to string
			mOutput += Integer.toHexString(b);
		}
		// hex string to uppercase
		return mOutput.toUpperCase();
	}

	private static void generateRandomNumber() {
		String random = UUID.randomUUID().toString();
		_srcCode = random;
		_openUdid = Md5(random);
		_time = System.currentTimeMillis();
	}

	private static void generateRandomNumber1() {
		_openUdid1 = Md5(UUID.randomUUID().toString());
	}

	private static void generateRandomNumber2() {
		_openUdid2 = Md5(UUID.randomUUID().toString());
	}

	@SuppressLint("DefaultLocale")
	// /
	private static void generateSystemId() {
		// update , never reach here
		// only reach here for very narrow chances (android 2.2 , no wifi , no
		// bluetooth)
		// this always return sth.
		String fp = String.format("%s/%s/%s/%s:%s/%s/%s:%s/%s/%d-%s-%s-%s-%s",
				Build.BRAND, Build.PRODUCT, Build.DEVICE, Build.BOARD,
				Build.VERSION.RELEASE, Build.ID, Build.VERSION.INCREMENTAL,
				Build.TYPE, Build.TAGS, Build.TIME, Build.DISPLAY, Build.HOST,
				Build.MANUFACTURER, Build.MODEL);

		CommonUtil.printDLog(LOG_TAG + "-generateSystemId", fp);
		if (null != fp) {
			_openUdid = Md5(fp);
			_time = System.currentTimeMillis();
		}
	}

	public static void main(String[] args) {
		// com.easou.999fc996400d6cf8c0a3dad71fb5b423 460016683607516
		System.out.println(Md5(String.format("%s.%s", "com.easou", "null")));
		System.out.println(Md5(String.format("%s.%s", "com.easou",
				"WIFIMAC:c4:6a:b7:86:b1:bb")));
		// 6406EB04CD4E2F30082A1142F4788871

		System.out.println(Md5(String.format("%s.%s", "com.easou",
				"866445021504758")));
		System.out.println("00:00:00:00:00:00".equals("00:00:00:00:00:00"));
	}
}
