/**
 * @工程 androidshare
 * @文件 Scaner.java
 * @时间 2014-5-29 下午6:24:40
 * @作者  赵自强（shenbaise1001@126.com）
 * @描述 
 */
package com.easou.users.analysis.common;

import java.lang.ref.WeakReference;
import java.util.List;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

import android.app.Activity;
import android.content.Context;

import com.easou.users.analysis.collect.DatabaseAdapater;
import com.easou.users.analysis.entity.ShareLogEntitiy;

/**
 * @author 赵自强（shenbaise1001@126.com）
 * @desc 扫描分享日志。未能成功回调的日志进行上传。
 */
public class Scaner {
	
	private static Scaner scaner = null;
	private static int timeOut = 1000 * 60 * 10;	// 10分钟未回调的记录进行上传。
	ScheduledExecutorService ses = Executors.newScheduledThreadPool(1);
	
	public static void scan(Context context){
		if(null == scaner){
			scaner = new Scaner(context);
		}
	}
	
	private Scaner(final Context context) {
		final WeakReference<Context> wf= new WeakReference<Context>(context);
		init(wf);
	}
	
	private void init(final WeakReference<Context> wf){
		ses.scheduleWithFixedDelay(new Runnable() {
			@Override
			public void run() {
				Context wfContext = wf.get();
				if(wfContext != null){
					List<ShareLogEntitiy> logs = DatabaseAdapater.getDatabaseAdapater(wfContext).getShareLogEntities();
					if (null != logs) {
						for (ShareLogEntitiy log : logs) {
							if (System.currentTimeMillis() - Long.valueOf(log.getTime()) > timeOut) {
								log.setStatus("未回调");
								ShareLogEntitiy.uploadLog(log, (Activity) wfContext);
								DatabaseAdapater.getDatabaseAdapater(wfContext).deleteShareLog(log.getId());
							}
						}
					}
				}
			}
		}, 0, 6000, TimeUnit.SECONDS);
	}
}
