package com.easou.users.analysis.common;

import java.math.BigDecimal;

import android.annotation.TargetApi;
import android.net.TrafficStats;

@TargetApi(8)
public class TrafficMonitoring {
	long lastTraffic = 0;
	long currentTraffic;

	// 构造函数
	public TrafficMonitoring() {
	}

	// 查询手机总流量
	public static long traffic_Monitoring() {
		try {
			int currentapiVersion = android.os.Build.VERSION.SDK_INT;
			if (currentapiVersion >= android.os.Build.VERSION_CODES.FROYO) {
				long recive_Total = TrafficStats.getTotalRxBytes();
				long send_Total = TrafficStats.getTotalTxBytes();
				long total = recive_Total + send_Total;
				return total;
			}
		} catch (Exception e) {
			return 0;
		}
		return 0;
	}

	// 查询手机的Mobile上行流量
	public static long mReceive() {
		try {
			int currentapiVersion = android.os.Build.VERSION.SDK_INT;
			if (currentapiVersion >= android.os.Build.VERSION_CODES.FROYO) {
				return TrafficStats.getMobileRxBytes();
			} else {
				return 0;
			}
		} catch (Exception e) {
			return 0;
		}
	}

	// 查询手机的Mobile下行流量
	public static long mSend() {
		try {
			int currentapiVersion = android.os.Build.VERSION.SDK_INT;
			if (currentapiVersion >= android.os.Build.VERSION_CODES.FROYO) {
				return TrafficStats.getMobileTxBytes();
			} else {
				return 0;
			}
		} catch (Exception e) {
			return 0;
		}

	}

	// 查询手机的WIFI下行流量
	public static long wSend() {
		try {
			int currentapiVersion = android.os.Build.VERSION.SDK_INT;
			if (currentapiVersion >= android.os.Build.VERSION_CODES.FROYO) {
				return TrafficStats.getTotalTxBytes()
						- TrafficStats.getMobileTxBytes();
			} else {
				return 0;
			}
		} catch (Exception e) {
			return 0;
		}
	}

	// 查询手机Wifi的上行流量
	public static long wReceive() {
		try {
			int currentapiVersion = android.os.Build.VERSION.SDK_INT;
			if (currentapiVersion >= android.os.Build.VERSION_CODES.FROYO) {
				return TrafficStats.getTotalTxBytes()
						- TrafficStats.getMobileRxBytes();
			} else {
				return 0;
			}
		} catch (Exception e) {
			return 0;
		}
	}

	// 查询某个Uid的下行值
	public static long monitoringEachApplicationReceive(int uid) {
		try {
			int currentapiVersion = android.os.Build.VERSION.SDK_INT;
			if (currentapiVersion >= android.os.Build.VERSION_CODES.FROYO) {
				return TrafficStats.getUidRxBytes(uid);
			} else {
				return 0;
			}
		} catch (Exception e) {
			return 0;
		}
	}

	// 查询某个Uid的上行值
	public static long monitoringEachApplicationSend(int uid) {
		try {

			int currentapiVersion = android.os.Build.VERSION.SDK_INT;
			if (currentapiVersion >= android.os.Build.VERSION_CODES.FROYO) {
				return TrafficStats.getUidTxBytes(uid);
			} else {
				return 0;
			}
		} catch (Exception e) {
			return 0;
		}
	}

	// 流量转化
	public static String convertTraffic(long traffic) {
		int currentapiVersion = android.os.Build.VERSION.SDK_INT;
		if (currentapiVersion >= android.os.Build.VERSION_CODES.FROYO) {
			BigDecimal trafficKB;
			BigDecimal trafficMB;
			BigDecimal trafficGB;

			BigDecimal temp = new BigDecimal(traffic);
			BigDecimal divide = new BigDecimal(1000);
			trafficKB = temp.divide(divide, 2, 1);
			if (trafficKB.compareTo(divide) > 0) {
				trafficMB = trafficKB.divide(divide, 2, 1);
				if (trafficMB.compareTo(divide) > 0) {
					trafficGB = trafficMB.divide(divide, 2, 1);
					return trafficGB.doubleValue() + "GB";
				} else {
					return trafficMB.doubleValue() + "MB";
				}
			} else {
				return trafficKB.doubleValue() + "KB";
			}

		} else {
			return "0";
		}

	}
}
