/**
 * @工程 DataCollect
 * @文件 ShareLogEntitiy.java
 * @时间 2014-5-14 下午2:38:54
 * @作者  赵自强（shenbaise1001@126.com）
 * @描述 
 */
package com.easou.users.analysis.entity;

import java.io.File;

import org.json.JSONStringer;

import android.content.Context;

import com.easou.users.analysis.UID;
import com.easou.users.analysis.buildreport.ReportBuilder;
import com.easou.users.analysis.common.CommonConfig;
import com.easou.users.analysis.common.CommonUtil;
import com.easou.users.analysis.common.GZip;
import com.easou.users.analysis.common.OpenUDID;
import com.easou.users.analysis.common.Send;
import com.easou.users.analysis.mobilephoneInfo.PhoneParameter;

/**
 * @author 赵自强（shenbaise1001@126.com）
 * @desc
 */
public class ShareLogEntitiy implements LogDataInterFace {
	
	private String id = "";
	private String status = "-";
	private String time = "";
	private String share_page = "";
	private String share_sns = "";
	private String share_title = "";
	private String share_content = "";
//	private ShareType share_type = ShareType.text;
	private String share_type = ShareType.text.name();
	private String share_url = "";
	private String share_src = "";
	private String extra = "";
	/**
	 * 空构造
	 */
	public ShareLogEntitiy() {
		this.id = UID.getUID();
	}
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	
	public String getStatus() {
		return status;
	}
	/**
	 * 设置分享状态，成功、失败
	 * @param status
	 */
	public void setStatus(String status) {
		this.status = status;
	}
	public String getTime() {
		return time;
	}
	public void setTime(String time) {
		this.time = time;
	}
	public String getShare_page() {
		return share_page;
	}
	/**
	 * 分享时的页面activity
	 * @return
	 */
	public void setShare_page(String share_page) {
		this.share_page = share_page;
	}
	public String getShare_sns() {
		return share_sns;
	}
	/**
	 * 分享平台：微信、QQ等
	 * @param share_sns
	 */
	public void setShare_sns(String share_sns) {
		this.share_sns = share_sns;
	}
	public String getShare_title() {
		return share_title;
	}
	/**
	 * 分享标题
	 * @param share_title
	 */
	public void setShare_title(String share_title) {
		this.share_title = share_title;
	}
	public String getShare_content() {
		return share_content;
	}
	/**
	 * 分享summary
	 * @return
	 */
	public void setShare_content(String share_content) {
		this.share_content = share_content;
	}
	public String getShare_type() {
		return share_type;
	}
	/**
	 * 分享类型，图文、视频，音乐等
	 * @param share_type
	 */
	public void setShare_type(String share_type) {
		this.share_type = share_type;
	}
	public String getShare_url() {
		return share_url;
	}
	/**
	 * 分享后，被点击后调转的链接
	 * @param share_url
	 */
	public void setShare_url(String share_url) {
		this.share_url = share_url;
	}
	public String getShare_src() {
		return share_src;
	}
	/**
	 * 分享图片、音乐等的链接
	 * @param share_src
	 */
	public void setShare_src(String share_src) {
		this.share_src = share_src;
	}
	public String getExtra() {
		return extra;
	}
	/**
	 * 附加字段，json格式
	 * @param extra
	 */
	public void setExtra(String extra) {
		this.extra = extra;
	}
	
	public String getJsonLog(Context ct){
		JSONStringer js = new JSONStringer();
		try {
			js.object().key(CommonConfig.TIME_FLAG).value(this.time)
			.key(CommonConfig.TPYE_FLAG).value(CommonConfig.TYPE_SHARE_INFO)
			.key(PhoneParameter.PHONE_SOFTNAME).value(ct.getPackageName() == null ? "" : ct.getPackageName())
			.key(PhoneParameter.PHONE_SOFTVERSION).value(CommonUtil.getVersion(ct))
			.key(CommonConfig.APP_KEY).value(CommonUtil.getAppKey(ct))
			.key(CommonConfig.CPID_FLAG).value(CommonUtil.getChannelId(ct))
			.key(CommonConfig.VERSION_CODE_FLAG).value(CommonConfig.VERSION_CODE == null ? "" : CommonConfig.VERSION_CODE)
			.key(PhoneParameter.PHONE_OPEN_UDID).value(OpenUDID.getCorpUDID("com.easou") == null ? "" : OpenUDID.getCorpUDID("com.easou"))
			.key(CommonConfig.SHARE_SNS).value(getShare_sns())
			.key(CommonConfig.SHARE_TITLE).value(getShare_title())
			.key(CommonConfig.SHARE_CONTENT).value(getShare_content())
			.key(CommonConfig.SHARE_TYPE).value(getShare_type())
			.key(CommonConfig.SHARE_SRC).value(getShare_src())
			.key(CommonConfig.SHARE_URL).value(getShare_url())
			.key(CommonConfig.SHARE_PAGE).value(getShare_page())
			.key(CommonConfig.SHARE_STATUS).value(getStatus())
			.key(CommonConfig.SHARE_NETWORK).value(CommonUtil.getNetworktype(ct) == null ? "" : CommonUtil.getNetworktype(ct))
			.key(CommonConfig.SHARE_EXTRA).value(getExtra())
			.endObject();
		} catch (Exception e) {
			CommonUtil.printELog("shareLogEntitity", e.getMessage());
		}
		return js.toString().replaceAll("\\\\", "");
	}
	
	public synchronized static void uploadLog(final ShareLogEntitiy logEntitiy,final Context ct){
		new Thread(new Runnable() {
			@Override
			public void run() {
				String jsonLog = logEntitiy.getJsonLog(ct);
				ReportBuilder reportBuilder = new ReportBuilder(ct,CommonConfig.TYPE_SHARE);
				CommonUtil.printDLog("easou_sdk", "提交share ---> " + jsonLog);
				File file = reportBuilder.buildReportFile(GZip.compress_(ct,jsonLog),CommonConfig.TYPE_SHARE);
				Send.getSend().sendFile2Server(ct, file, CommonConfig.TYPE_SHARE, 30000, 30000);
			}
		}).start();
	}
}
