package com.easou.users.analysis.exception;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.io.Writer;
import java.lang.Thread.UncaughtExceptionHandler;

import android.content.Context;

import com.easou.users.analysis.collect.ExceptionCollect;
import com.easou.users.analysis.common.CommonConfig;
import com.easou.users.analysis.common.CommonUtil;
import com.easou.users.analysis.entity.ExceptionEntity;

public class GlobalHandler implements UncaughtExceptionHandler {

	private static GlobalHandler myCrashHandler = null;
	private Context context = null;

	/**
	 * 私有构造
	 * 
	 * @param context
	 */
	private GlobalHandler(Context context) {
		this.context = context;
	}
	/**
	 * 获取实例
	 * @param context
	 * @return
	 */
	public static GlobalHandler getInstance(Context context) {
		if (myCrashHandler != null && myCrashHandler.context!=context) {
			return myCrashHandler;
		} else {
			myCrashHandler = new GlobalHandler(context);
			return myCrashHandler;
		}
	}


	@Override
	public void uncaughtException(Thread thread, Throwable ex) {
		try {
			String errorinfo = getErrorInfo(ex);
			String ssString = errorinfo.substring(errorinfo.indexOf("Caused by:"));
			String[] ss = ssString.split("\n\t");
			String headstring = ss[0] + "\n\t" + ss[1] + "\n\t" + ss[2] + "\n\t";
			String newErrorInfoString = headstring + errorinfo;
			Exception excp = new Exception("uncaughtException:" + newErrorInfoString);
			excp.setStackTrace(ex.getStackTrace());
			
			String stack = "";
			int count = excp.getStackTrace().length;

			for (int i = 0; i < count; i++) {
				stack += "at " + excp.getStackTrace()[i].toString() + "\r\n";
			}

			ExceptionEntity ee = new ExceptionEntity();
			ee.setClassName(this.getClass().getName());
			ee.setMessage(excp.getMessage() + "");
			ee.setType(excp.getClass().getName());
			if (("The operation timed out").equals(ee.getMessage())) {
				return;
			} else if (("Network unreachable").equals(ee.getMessage())) {
				return;
			} else if (("No route to host").equals(ee.getMessage())) {
				return;
			} else if (("The connection was reset").equals(ee.getMessage())) {
				return;
			} else if (ee.getMessage().contains("time out")) {
				return;
			} else
				ee.setStack(stack);
			ee.setTime(System.currentTimeMillis() + "");

			new ExceptionCollect(CommonConfig.TYPE_EXCEPTIONINFO).collect(context, ee,false);
		} catch (Exception e) {
			CommonUtil.printELog("easou_skd"+this.getClass().getName(), e.getMessage());
		}
	}

	private String getErrorInfo(Throwable t) {
		Writer writer = new StringWriter();
		PrintWriter pw = new PrintWriter(writer);
		t.printStackTrace(pw);
		pw.close();
		String error = writer.toString();
		return error;
	}
	
}
